/* The <dir.h> header gives the layout of a directory. */
#ifndef FS_DIR_H
#define FS_DIR_H
#include "sys/type.h"

#define DIRSIZ_V1 		14 // minix v1
#define DIRSIZ_V1_REV 	30 // minix v1 e v2 con nomi da 30B
#define DIRSIZ    		60 // minix v3

struct direct_V1
{
	uint16_t d_ino;
	char d_name[DIRSIZ_V1];
};

struct direct_V1_REV
{
	uint16_t d_ino;
	char d_name[DIRSIZ_V1_REV];
};


// il programma utente deve vedere solo questa
struct direct_V3
{
	ino_t d_ino;
	char d_name[DIRSIZ];
};

typedef direct_V3 direct;

// tipo opaco definito da me
// pos: indice della prossima entrata da leggere
struct DIR
{
	int fd; // file descriptor
	off_t pos;
	off_t dir_size;
	char version; // versione del filesystem usato
};

#endif /* _DIR_H */
