#ifndef FS_FILE_H
#define FS_FILE_H
#include "const.h"

struct filp {
	mode_t filp_mode;   // RW bits, telling how file is opened 
	int filp_flags;     // flags from open and fcntl 
	int filp_count;     // how many file descriptors share this slot?
	inode *filp_ino;    // pointer to the inode 
	off_t filp_pos;     // file position 
	uint32_t mutex;		// semaforo di mutua esclusione
};

#define FILP_CLOSED     0       /* filp_mode: associated device closed */

#define NIL_FILP (struct filp *) 0      /* indicates absence of a filp slot */

#endif
