#ifndef _FS_FPROC_H
#define _FS_FPROC_H
#include "file.h"
#include "sys/limits.h"

// Ogni processo aperto nel sistema ha un'entrata in questa tabella che rappresenta
// un estensione del descrittore del processo e serve a supportare il filesystem
// La struttura dati è ispirata al descrittore di processo di MINIX v2.
// Per accedere ad una entrata della tabella si usa il pid del processo
struct fproc {
	mode_t fp_umask;              // mask set by umask system call 
	inode *fp_workdir;     		// pointer to working directory's inode 
	inode *fp_rootdir;     		// pointer to current root dir (see chroot) 
	filp *fp_filp[OPEN_MAX]; 	// the file descriptor table 
 	uid_t fp_realuid;             // real user id 
   	uid_t fp_effuid;              // effective user id 
	gid_t fp_realgid;             // real group id 
	gid_t fp_effgid;              // effective group id
	int fp_cum_io_partial;      	// partial byte count if rd/wr can't finish
	unsigned fp_cloexec;          // bit map for POSIX Table 6-2 FD_CLOEXEC 
};

extern fproc *get_fproc(pid_t pid);
// extern fproc des_fproc[NUM_TSS];
 #endif
