#ifndef _FS_H
#define _FS_H

#define _SYSTEM

#include "sys/const.h"
#include "sys/type.h"
#include "sys/errno.h"
#include "inode.h"
#include "fproc.h"
#include "super.h"
#include "sys/errno.h"
#include "blocco_fis.h"
#include "proto.h"

///////////////////////////////////////////////////////////////////////////////
//                        CHIAMATE DI SISTEMA USATE                          //
///////////////////////////////////////////////////////////////////////////////
extern "C" pid_t getpid();
extern "C" pid_t getppid();
extern "C" uid_t getuid();
extern "C" gid_t getgid();
extern "C" void panic(const char *msg);
extern "C" void sem_wait(uint32_t sem);
extern "C" void sem_signal(uint32_t sem);
extern "C" uint32_t sem_ini(int val);

void *mem_alloc(uint32_t dim);
void mem_free(void *p);
/////////////////////////

uint32_t __boot_block_offset();
uint32_t __super_block_offset();
uint32_t __imap_offset();
uint32_t __zmap_offset();
void _write_imap();
void _write_zmap();

// fs_init.cpp 
void read_super_blockCE();
extern "C" void c_fs_init();
extern "C" void c_fs_fork(pid_t pid, pid_t ppid);
extern "C" void c_fs_flush();

// tables.cpp
fproc *get_fproc(pid_t pid);
void init_fproc_table();
void init_filps_table();

#endif
