#include "libce.h"
#include "costanti.h"
#include "sys/const.h"
#include "fs/const.h"
#include "fs/fs.h"
#include "sys/dir.h"
#include "fs/glo.h"

//extern uint32_t log2(uint32_t n);
extern "C" void c_readhd_n(uint16_t vetti[], uint32_t primo,
		uint8_t quanti, uint8_t &errore);
extern "C" void c_dmareadhd_n(uint16_t vetti[], uint32_t primo,
		uint16_t quanti, uint8_t &errore);
extern "C" void c_dmawritehd_n(uint16_t vetti[], uint32_t primo,
		uint16_t quanti, uint8_t &errore);
/*
uint32_t __inode_table_disk_size()
{
	return MAX_INODES*sizeof(d2_inode);
}

uint32_t __inode_table_size()
{
	return NR_INODES*sizeof(inode);
}

//  calcola le dimensione in byte disponbile per l'allocazione dei file
uint32_t __data_size()
{
	// dimensione della sezione dati + dimensione della sezione zone_map
	uint64_t zmap_plus_data_size = DISK_SIZE -(BOOT_BLOCK_BYTES+SUPER_BLOCK_BYTES+MAX_INODES*INODE_SIZE);
	// tolgo una zona per avere un po' di margine e non superare le dimensioni del disco
	uint64_t data_size = (zmap_plus_data_size*ZONE_SIZE*8)/(1+ZONE_SIZE*8) - ZONE_SIZE;
	return (uint32_t)data_size;
}

//  calcola le dimensione in byte della zone_map
uint32_t __zmap_size(uint32_t data_size)
{
	return CEILING((data_size)/(ZONE_SIZE*8));
}
*/
uint16_t __n_sectors_imap()
{
 	return NUM_SECTORS(super_b->s_imap_blocks);
}

uint16_t __n_sectors_zmap()
{
	return NUM_SECTORS(super_b->s_zmap_blocks);
}
/*
uint16_t __n_sectors_inode_table()
{
	return CEILING(__inode_table_disk_size()/DIM_SECTOR);
} */

// ( OFFSET IN BLOCCHI FISICI 
uint32_t __boot_block_offset()
{
	return 0;
}

uint32_t __super_block_offset()
{
	return __boot_block_offset() + BOOT_BLOCK_BYTES/DIM_SECTOR;
}

uint32_t __imap_offset()
{
	return __super_block_offset() + SUPER_BLOCK_BYTES/DIM_SECTOR;
}

uint32_t __zmap_offset()
{
	return __imap_offset() + __n_sectors_imap();
}
/*
uint32_t __inode_table_offset(uint32_t data_size)
{
	return __zmap_offset() + CEILING(__zmap_size(data_size)/DIM_SECTOR);
}

// )

uint32_t __first_data_zone()
{
	uint32_t first_block = __zmap_offset() + __inode_table_offset(__data_size()) + CEILING((INODE_SIZE*MAX_INODES)/BLOCK_SIZE);
	uint32_t scale = log2(ZONE_SIZE/BLOCK_SIZE);
	return first_block >> scale;
}

void __read_zone(uint32_t zone_numb, char* buf)
{
	natb errore;
	//flog(LOG_DEBUG,"leggo la zona e la scrivo a partire da %d",buf);
	super_block *sb = get_super(CE_DEV);
	uint32_t first_block = zone_numb << sb->s_log_zone_size;
	c_dmareadhd_n((natw*)buf, first_block, ZONE_SIZE/DIM_BLOCK, errore);
}

void __write_zone(uint32_t zone_numb, char* buf)
{
	natb errore;
	super_block *sb = get_super(CE_DEV);
	uint32_t first_block = zone_numb << sb->s_log_zone_size;
	flog(LOG_DEBUG,"scrivo la zona a partire dal blocco:%d n_blocchi:%d zone_numb:%d",first_block, ZONE_SIZE/DIM_BLOCK,zone_numb);
	c_dmawritehd_n((natw*)buf, first_block, ZONE_SIZE/DIM_BLOCK, errore);
}
*/

uint32_t log2(uint32_t x)
{
	uint32_t ans = 0 ;
  	while( x >>=1 ) ans++;
  	return ans ;
}

void _write_zmap()
{
	natb errore;
	c_dmawritehd_n ((natw*)zone_map, __zmap_offset(), __n_sectors_imap(), errore);
}

void _write_imap()
{
	natb errore;
	c_dmawritehd_n ((natw*)inode_map, __imap_offset(), __n_sectors_zmap(), errore);
}

/*===========================================================================*
 *				conv2					     *
 *===========================================================================*/
PUBLIC uint16_t conv2(int norm, uint16_t w)
//int norm;			/* TRUE if no swap, FALSE for byte swap */
//int w;				/* promotion of 16-bit word to be swapped */
{
/* Possibly swap a 16-bit word between 8086 and 68000 byte order. */
  if (norm) return( (unsigned) w & 0xFFFF);
  return( ((w&BYTE) << 8) | ( (w>>8) & BYTE));
}

/*===========================================================================*
 *				conv4					     *
 *===========================================================================*/
PUBLIC uint32_t conv4(int norm, uint32_t x)
//int norm;			/* TRUE if no swap, FALSE for byte swap */
//long x;				/* 32-bit long to be byte swapped */
{
/* Possibly swap a 32-bit long between 8086 and 68000 byte order. */
  unsigned lo, hi;
  long l;
  
  if (norm) return(x);			/* byte order was already ok */
  lo = conv2(FALSE, (int) x & 0xFFFF);	/* low-order half, byte swapped */
  hi = conv2(FALSE, (int) (x>>16) & 0xFFFF);	/* high-order half, swapped */
  l = ( (long) lo <<16) | hi;
  return(l);
}
