#ifndef _PROTO_H
#define _PROTO_H
/* Structs used in prototypes must be declared as such first. */
struct buf;
struct filp;		
struct inode;
struct super_block;
union blocco_fis; //introdotto in quanto non ho implementato la cache

/* cache.c */
zone_t alloc_zone(dev_t dev, zone_t z);
//void flushall(dev_t dev);
void free_zone(dev_t dev, zone_t numb);
//struct buf *get_block(dev_t dev, block_t block,int only_search);
///void invalidate(dev_t device)				;
//void put_block(struct buf *bp, int block_type)		;
//void rw_scattered(dev_t dev, struct buf **bufq, int bufqsize, int rw_flag);

#if ENABLE_CACHE2
/* cache2.c */
void init_cache2(unsigned long size)			;
int get_block2(struct buf *bp, int only_search)		;
void put_block2(struct buf *bp)				;
void invalidate2(dev_t device)				;
#endif

/* filedes.c */
struct filp *find_filp(struct inode *rip, mode_t bits);
int get_fd(int start, mode_t bits, int *k, struct filp **fpt) ;
struct filp *get_filp(int fild);

/* inode.c */
struct inode *alloc_inode(dev_t dev, mode_t bits);
void dup_inode(struct inode *ip);
void free_inode(dev_t dev, ino_t numb);
struct inode *get_inode(dev_t dev, ino_t numb);
void put_inode(struct inode *rip);
//void update_times(struct inode *rip);
void rw_inode(struct inode *rip, int rw_flag);
void wipe_inode(struct inode *rip);

/* link.c */
int do_link(char *name1, char* name2);
int do_unlink(char *name, int call_nr);
int do_rename(char *name1, char *name2);
void truncate(struct inode *rip);

/* open.c */
int do_close(int fd);
int do_creat(const char *pathname, mode_t mode);
//int do_lseek(void);
//int do_mknod(void);
int do_mkdir(const char *name, mode_t mode);
int do_open(const char *pathname, int flags, mode_t mode);

/* path.c */
struct inode *advance(struct inode *dirp, char *string);
int search_dir(struct inode *ldir_ptr, char *string, ino_t *numb, int flag);
struct inode *eat_path(const char *path);
struct inode *last_dir(const char *path, char *string);

/* pipe.c */
/*int do_pipe(void);
int do_unpause(void);
int pipe_check(struct inode *rip, int rw_flag,
			int oflags, int bytes, off_t position, int *canwrite, int notouch);
void release(struct inode *ip, int call_nr, int count);
void revive(int proc_nr, int bytes);
void suspend(int task);
int select_request_pipe(struct filp *f, int *ops, int bl)	;
int select_cancel_pipe(struct filp *f);
int select_match_pipe(struct filp *f);
void unsuspend_by_proc(int);*/

/* protect.c */
int do_access(void);
int do_chmod(void);
//int do_chown(void);
//int do_umask(void);
int forbidden(struct inode *rip, mode_t access_desired)	;
int read_only(struct inode *ip)				;

/* read.c */
int do_read(int fd, void *buf, uint32_t nbytes);
/*struct buf *rahead(struct inode *rip, block_t baseblock,
			off_t position, unsigned bytes_ahead);
void read_ahead(void);*/
block_t read_map(struct inode *rip, off_t position)	;
int read_write(int rw_flag, int fd, char* buff, uint32_t nbytes); // eseguita in mutua esclusione sul file
//zone_t rd_indir(struct buf *bp, int index);
zone_t rd_indir(blocco_fis *bp, int index);

/* stadir.c */
/*int do_chdir(void);
int do_fchdir(void);
int do_chroot(void);
int do_fstat(void);
int do_stat(void);
int do_fstatfs(void);*/

/* super.c */
bit_t alloc_bit(struct super_block *sp, int map, bit_t origin);
void free_bit(struct super_block *sp, int map, bit_t bit_returned);
struct super_block *get_super(dev_t dev);
int mounted(struct inode *rip);
int read_super(struct super_block *sp);
int get_block_size(dev_t dev);

/* utility.c */
//time_t clock_time(void);
uint16_t conv2(int norm, uint16_t w);
uint32_t conv4(int norm, uint32_t x);

/* write.c */
void clear_zone(struct inode *rip, off_t pos, int flag);
int do_write(int fd, char *buf, uint32_t nbytes);
//struct buf *new_block(struct inode *rip, off_t position);
//void zero_block(struct buf *bp)	;
blocco_fis *new_block(inode *rip, off_t position);
void zero_block(blocco_fis *bp);

#endif
