#include "costanti.h"
#include "libce.h"
#include "fs.h"
#include "const.h"

//puntatore all'area di memoria contenente la copia del superblocco
super_block super_b[NR_SUPERS];
// tabella degli inode(in memoria)
inode inodes_table[NR_INODES]; 
// tabella dei file aperti
// Non appena un processo apre un file viene occupata un'entrata
// di questa tabella. I processi generati tramite fork condividono
// delle entrate in questa tabella.
filp filps_table[NR_FILPS];
// Tabella dei descrittori di processo
fproc des_fproc[NUM_TSS];

fproc *get_fproc(pid_t pid)
{
	return &des_fproc[pid>>4];
}

void init_fproc_table()
{
	memset(des_fproc,0,sizeof(fproc)*NUM_TSS);
}

void init_filps_table()
{
	for(int i=0; i<NR_FILPS; i++){
		if( (filps_table[i].mutex = sem_ini(1)) == 0xFFFFFFFF ){
			panic("Errore inizializzazione filps_table");
		}
	}
}