// sys.h
// header per l' interfaccia offerta dal nucleo e dal modulo di IO
//

#ifndef SYS_H_
#define SYS_H_

#include <libce.h>
#include <costanti.h>
#include "sys/type.h"
#include "sys/dir.h"
#include "sys/stat.h"
#include "sys/errno.h"

extern "C" void log(log_sev sev, const char* buf, natl quanti);

extern "C" natl activate_p(void f(int), int a, natl prio, natl liv);
extern "C" void terminate_p();
extern "C" natl sem_ini(int val);
extern "C" void sem_wait(natl sem);
extern "C" void sem_signal(natl sem);
extern "C" void delay(natl n);

extern "C" void readse_n(natl serial, natb vetti[], natl quanti, natb &errore);
extern "C" void readse_ln(natl serial, natb vetti[], natl &quanti, natb &errore);
extern "C" void writese_0(natl serial, const natb vetto[], natl &quanti);
extern "C" void writese_n(natl serial, const natb vetto[], natl quanti);

extern "C" void iniconsole(natb cc);
extern "C" void readconsole(char* buff, natl& quanti);
extern "C" void writeconsole(const char* buff);

#ifndef VERS_FS
#define VERS_FS
#define V1		  0x11	// filesystem V1, nomi file di 14B
#define V1_REV	  0x12  // filesystem V1, nomi file di 30B
#define V2		  0x21	// filesystem V2, nomi file di 14B
#define V2_REV	  0x22 	// filesystem V2, nomi file di 30B
#define V3		  0x32	// filesystem V3, nomi di 60B
#endif

extern "C" pid_t fork();
extern "C" uid_t getuid();
extern "C" uid_t getgid();
extern "C" uid_t getpid();
extern "C" uid_t getppid();
int open(const char *pathname, int flags);
int open(const char *pathname, int flags, mode_t mode);
extern "C" int creat(const char *path, mode_t mode);
extern "C" int close(int fd);

DIR *opendir(const char *name);
int readdir_r(DIR *dir, direct *entry, direct **result);
int closedir(DIR *dir);
void rewinddir(DIR *dir);
extern "C" int read(int fd, void *buf, natl count);
extern "C" int write(int fd, const void *buf, natl count);
extern "C" int link(const char *oldpath, const char *newpath);
extern "C" int unlink(const char *pathname);
extern "C" int mkdir(const char *pathname, mode_t mode);
extern "C" int rmdir(const char *path);
#endif

